Attribute VB_Name = "Decode"
Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double)
On Error Resume Next
sCDKey = Replace(sCDKey, "-", ""): sCDKey = Replace(sCDKey, " ", ""): sCDKey = KillNull(sCDKey)
If Len(sCDKey) = 13 Then
    sCDKey = DecodeStarcraftKey(sCDKey)
ElseIf Len(sCDKey) = 16 Then
    sCDKey = DecodeD2Key(sCDKey)
Else
    Exit Sub
End If
dProductId = Val("&H" & Left$(sCDKey, 2))
If Len(sCDKey) = 13 Then
    dValue1 = Val(Mid$(sCDKey, 3, 7)): dValue2 = Val(Mid$(sCDKey, 10, 3))
ElseIf Len(sCDKey) = 16 Then
    dValue1 = Val("&H" & Mid$(sCDKey, 3, 6)): dValue2 = Val("&H" & Mid$(sCDKey, 9))
End If
End Sub
Public Function DecodeD2Key(ByVal Key As String) As String
Dim r As Double
Dim n As Double
Dim n2 As Double
Dim v As Double
Dim v2 As Double
Dim keyvalue As Double
Dim c1 As Byte
Dim c2 As Byte
Dim c As Byte
Dim bValid As Boolean
Dim i As Integer
Dim aryKey(0 To 15) As String
Dim codevalues As String
    
codevalues = "246789BCDEFGHJKMNPRTVWXZ"
r = 1
keyvalue = 0
For i = 1 To 16
    aryKey(i - 1) = Mid$(Key, i, 1)
Next i
For i = 0 To 15 Step 2
    c1 = InStr(1, codevalues, aryKey(i)) - 1
    If c1 = -1 Then c1 = &HFF
    n = c1 * 3
    c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
    If c2 = -1 Then c2 = &HFF
    n = c2 + n * 8
    If n >= &H100 Then
        n = n - &H100
        keyvalue = keyvalue Or r
    End If
    n2 = n
    n2 = RShift(n2, 4)
    aryKey(i) = GetHexValue(n2)
    aryKey(i + 1) = GetHexValue(n)
    r = LShift(r, 1)
    
Cont:
    Next i
    v = 3
    For i = 0 To 15
        c = GetNumValue(aryKey(i))
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
    Next i
    v = v And &HFF
    For i = 15 To 0 Step -1
        c = Asc(aryKey(i))
        If i > 8 Then
            n = i - 9
        Else
            n = &HF - (8 - i)
        End If
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(c)
    Next i
    v2 = &H13AC9741
    For i = 15 To 0 Step -1
        c = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(c)
        If Val(c) <= 55 Then
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
        ElseIf Val(c) < 65 Then
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = Chr$(c2)
        End If
    Next i
    DecodeD2Key = Join(aryKey, "")
    Erase aryKey()
End Function
Public Function DecodeStarcraftKey(ByVal sKey As String) As String
On Error Resume Next
    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, c As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    For i = 1 To 13
        aryKey(i - 1) = Mid$(sKey, i, 1)
    Next i
    v = 3
    For i = 0 To 11
        c = aryKey(i)
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
    Next i
    v = v Mod 10
    If Hex(v) = aryKey(12) Then
        bValid = True
    End If
    v = 194
    For i = 11 To 0 Step -1
        If v < 7 Then GoTo continue
        c = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = c
    Next i
continue:
    v2 = &H13AC9741
    For i = 11 To 0 Step -1
        c = UCase$(aryKey(i))
        aryKey(i) = c
        If Asc(c) <= Asc("7") Then
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
        ElseIf Asc(c) < 65 Then
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = c2
        End If
    Next i
    DecodeStarcraftKey = Join(aryKey, "")
    Erase aryKey()
End Function
Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
LShift = CDbl(pnValue * (2 ^ pnShift))
End Function
Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function
Public Function KillNull(ByVal text As String) As String
    Dim i As Integer
    i = InStr(1, text, Chr(0))
    If i = 0 Then: KillNull = text: Exit Function
    KillNull = Left(text, i - 1)
End Function
Public Function GetHexValue(ByVal v As Long) As String
    v = v And &HF
    If v < 10 Then: GetHexValue = Chr$(v + &H30): Else GetHexValue = Chr$(v + &H37)
End Function
Public Function GetNumValue(ByVal c As String) As Long
On Error Resume Next
    c = UCase(c)
    If IsNumeric(c) Then: GetNumValue = Asc(c) - &H30: Else GetNumValue = Asc(c) - &H37
End Function
